| IGLib 1.5 The IGLib base library for development of numerical, technical and business applications.

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Properties Events
Classes | Public Member Functions | Static Public Member Functions | Public Attributes | Static Public Attributes | Protected Member Functions | Static Protected Member Functions | Protected Attributes | Properties | Private Attributes | List of all members
IG.Num.NeuralTrainingParameters Class Reference

Contains Parameters that define neural network architecture and trainig procedure, together with achieved results after training such as various error norms. More...

Collaboration diagram for IG.Num.NeuralTrainingParameters:
[legend]

## Classes
class | ComparerBase
| Base comparer class (implementation of the IComparer<NeuralTrainingParameters> interface) for conmparing objects of type NeuralTrainingParameters More...
class | ComparerErrorTrainingVector
class | ComparerTrainingTime

## Public Member Functions
void | SetEpochNumbers (int[] epochNumbers)
| Sets the list of epoch numbers at which convergence data was sampled. More...
void | SetEpochNumbers (List< int > epochNumbers)
| Sets the list of epoch numbers at which convergence data was sampled. More...
void | SetEpochErrorsRms (double[] errors)
| Sets the list of sampled RMS errors that correspond to epoch numbers from EpochNumbers. More...
void | SetEpochErrorsRms (List< double > errors)
| Sets the list of sampled RMS errors corresponding to epoch numbers from EpochNumbers. More...
void | SetEpochErrorsAbs (double[] errors)
| Sets the list of sampled absolute errors that correspond to epoch numbers from EpochNumbers. More...
void | SetEpochErrorsAbs (List< double > errors)
| Sets the list of sampled absolute errors corresponding to epoch numbers from EpochNumbers. More...
void | CopyFrom (NeuralApproximatorBase nn)
| Copies current data from the specified neural network approximator. More...
void | CopyResultsFrom (NeuralApproximatorBase nn)
| Copies only results from the trained network to the current object. More...
void | CopyTo (NeuralApproximatorBase nn)
| Copies data that determine neural network and training procedure (such as network architecture, training parameters, tolerances, etc.) from the current object to the specified neural network approximator. This enables to restore training contitions of a peviour training procedure. More...

## Static Public Member Functions
static void | SaveJson (NeuralTrainingParameters trainingParameters, string filePath)
| Saves (serializes) the specified training parameters object to the specified JSON file. File is owerwritten if it exists. More...
static void | SaveJson (NeuralTrainingParameters trainingParameters, string filePath, bool append)
| Saves (serializes) the specified training parameters object to the specified JSON file. More...
static void | LoadJson (string filePath, ref NeuralTrainingParameters trainingParametersRestored)
| Restores (deserializes) a training parameters object from the specified file in JSON format. More...
static void | SaveJson (NeuralTrainingParameters[] trainingParameters, string filePath)
| Saves (serializes) the specified array of training parameters objects to the specified JSON file. File is owerwritten if it exists. More...
static void | SaveJson (NeuralTrainingParameters[] trainingParameters, string filePath, bool append)
| Saves (serializes) the specified array of training parameters objects to the specified JSON file. More...
static void | LoadJson (string filePath, ref NeuralTrainingParameters[] trainingParametersRestored)
| Restores (deserializes) an array of training parameters objects from the specified file in JSON format. More...
static void | SaveJson (List< NeuralTrainingParameters > trainingParameters, string filePath)
| Saves (serializes) the specified list of training parameters objects to the specified JSON file. File is owerwritten if it exists. More...
static void | SaveJson (List< NeuralTrainingParameters > trainingParameters, string filePath, bool append)
| Saves (serializes) the specified list of training parameters objects to the specified JSON file. More...
static void | LoadJson (string filePath, ref List< NeuralTrainingParameters > trainingParametersRestored)
| Restores (deserializes) a list of training parameters objects from the specified file in JSON format. More...
static void | SaveCSV (List< NeuralTrainingParameters > trainingParameters, string filePath)
| Saves the specified list of training parameters objects to the specified CSV file. More...
static ComparerTrainingTime | CreateComparerTrainingTime ()

## Public Attributes
List< IVector > | _errorsTrainingRmsList = null
List< IVector > | _errorsTrainingMaxList = null
List< IVector > | _errorsVerificationRmsList = null
List< IVector > | _errorsVerificationMaxList = null
bool | _convergenceRmsEnabled = false

## Static Public Attributes
static double | DefaultLearningRate = 0.1
| Default value for learning rate in neural networks. More...
static double | DefaultMomentum = 0.5
| Default value of momentum for neural networks. More...
static double | DefaultSigmoidAlphaValue = 1.5
| Default value of the sigmoid alpha value (used in networks with sigmoid activation functions). More...
static int | DefaultEpochsInBundle
| Default value for number of epochs in bundle (i.e. number of epochs performed at once, without any checks or output operations between). More...
static int | DefaultNumHiddenLayers = 1
| Default number of hidden layers. More...
static int | DefaultNumHiddenNeurons = 20
| Default number of hidden neurons in a layer More...
static int | DefaultMaxEpochs = 40000
| Default value for maximal number of epochs. More...
static IVector | DefaultToleranceRms = null
| Default value for tollerance on RMS error in neural networks. More...
static IVector | DefaultToleranceMax = null
| Default value for tollerance on max. abs. error in neural networks. More...
static double | DefaultToleranceRmsRelativeToRangeScalar = 0.1
| Default value for the tolerance on RMS error, relative to the output range. More...
static double | DefaultToleranceMaxRelativeToRangeScalar = 0
| Default value for the tolerance on max. abs. error, relative to the output range. More...
static int | DefaultInputLength = 1
| Default number of input neurons. More...
static int | DefaultOutputLength = 1
| Default number of output neurons. More...
static double | DefaultInputBoundSafetyFactor = 1.5
| Default number of input safety factor. More...
static double | DefaultOutputBoundSafetyFactor = 1.5
| Default number of output safety factor. More...

## Protected Member Functions
IComparer< IVector > | CreateComparerErrorTrainingRmsVector ()

## Static Protected Member Functions
static double | ErrorAverageCalc (List< IVector > ErrorConvergence, int NumLastErrors, int NumBundles, IVector scalingLength)
| Calculate average number of the desired number of first elements in the convergence list. More...
static double | ErrorAverageCalc (List< IVector > ErrorConvergence, int NumLastErrors, int NumBundles)
| Calculate average number of the desired number of first elements in the convergence list. More...

## Protected Attributes
double | _learningRate = DefaultLearningRate
double | _momentum = DefaultMomentum
double | _sigmoidAlphaValue = DefaultSigmoidAlphaValue
int | _maxEpochs = DefaultMaxEpochs
int | _epochInBundle = DefaultEpochsInBundle
IVector | _outputRange
IBoundingBox | _outputNeuronRange
IVector | _inputRange
IBoundingBox | _inputNeuronRange
IVector | _toleranceRms
IVector | _toleranceMax
int | _numHiddenLayers = DefaultNumHiddenLayers
int[] | _numHiddenNeurons = null
bool | _isNetworkTrained = false
IVector | _errorsTrainingRms
IVector | _errorsTrainingMax
IVector | _errorsTrainingMeanAbs
IVector | _errorsVerificationRms
IVector | _errorsVerificationMax
IVector | _errorsVerificationMeanAbs
int | _numEpochs = 0
double | _trainingTime = 0
double | _trainingCpuTime = 0
List< int > | _EpochNumbers
List< double > | _EpochErrorsRms
List< double > | _EpochErrorsAbs

## Properties
double | LearningRate`[get, set]`
| Learning rate. More...
double | Momentum`[get, set]`
| Momentum. Specifies how much changes of weight in the previous iterations affect changes in the current iterations. More...
double | SigmoidAlphaValue`[get, set]`
| Sigmoid alpha value (used in networks with sigmoid activation functions). More...
virtual int | InputLength`[get, set]`
| Gets or sets the number of input neurons. More...
virtual int | OutputLength`[get, set]`
| Gets or sets the number of output neurons. More...
virtual double | InputBoundSafetyFactor`[get, set]`
| Gets or sets input safety factor. More...
virtual double | OutputBoundSafetyFactor`[get, set]`
| Gets or sets output safety factor. More...
int | MaxEpochs`[get, set]`
| Maximal number of epochs performed in the training procedure. More...
int | EpochsInBundle`[get, set]`
| Number of epochs in bundle (i.e. number of epochs performed at once, without any checks or output operations between). More...
IVector | OutputRange`[get, set]`
| Range from actual outputs. More...
IBoundingBox | OutputNeuronRange`[get, set]`
| Bounding box from actual outputs. More...
IVector | InputRange`[get, set]`
| Range from actual inputs. More...
IBoundingBox | InputNeuronRange`[get, set]`
| Bounding box from actual inputs. More...
IVector | ToleranceRms`[get, set]`
| Tolerance over RMS error of output over training points. Training will continue until error becomes below tolerance or until maximal number of epochs is reached. If less or equal than 0 then this tolerance is not taken into account. More...
IVector | ToleranceMax`[get, set]`
| Tolerance on maximal error of output over training points. Training will continue until error becomes below tolerance or until maximal number of epochs is reached. If less or equal than 0 then this tolerance is not taken into account. More...
IVector | ToleranceRmsRelativeToRange`[get, set]`
| Relative tolerances on RMS errors of outputs over training points, relative to the correspoinding ranges of output data. More...
double | ToleranceRmsRelativeToRangeScalar`[get, set]`
| Scalar through which all components of the Relative tolerances on RMS errors of outputs can be set to the same value. More...
IVector | ToleranceMaxRelativeToRange`[get, set]`
| Relative tolerances on max. abs. errors of outputs over training points, relative to the correspoinding ranges of output data. More...
double | ToleranceMaxRelativeToRangeScalar`[get, set]`
| Scalar through which all components of the Relative tolerances on max. abs. errors of outputs can be set to the same value. More...
int | NumHiddenLayers`[get, set]`
| Number of Hideden layers. More...
int[] | NumHidenNeurons`[get, set]`
| Numbers of neurons in each hidden layer. More...
bool | IsNetworkTrained`[get, set]`
| Whether the network is trained (and results exist). More...
IVector | ErrorsTrainingRms`[get, set]`
| RMS errors calculated on training data. More...
List< IVector > | ErrorsTrainingRmsList`[get, set]`
| Convergence List of Rms errors calculated on training data. More...
IVector | ErrorsTrainingMax`[get, set]`
| Maximal errors calculated on training data. More...
List< IVector > | ErrorsTrainingMaxList`[get, set]`
| Convergence List of Maximal errors calculated on training data. More...
IVector | ErrorsTrainingMeanAbs`[get, set]`
| Mean absolute errors calculated on training data. More...
IVector | ErrorsVerificationRms`[get, set]`
| RMS errors calculated on verification data. More...
List< IVector > | ErrorsVerificationRmsList`[get, set]`
| Convergence List of RMS errors calculated on verification data. More...
IVector | ErrorsVerificationMax`[get, set]`
| Maximal errors calculated on verification data. More...
List< IVector > | ErrorsVerificationMaxList`[get, set]`
| Convergence List of Maximal errors calculated on verification data. More...
IVector | ErrorsVerificationMeanAbs`[get, set]`
| Maximal errors calculated on training data. More...
bool | SaveConvergenceRms`[get, set]`
int | NumEpochs`[get, set]`
| Number of epochs actually spent at training. More...
double | TrainingTime`[get, set]`
| Time spent for training. More...
double | TrainingCpuTime`[get, set]`
| CPU time spent for training. More...
List< int > | EpochNumbers`[get, protected set]`
| List of epoch numbers at which convergence data was sampled. More...
List< double > | EpochErrorsRms`[get, set]`
| List of sampled RMS errors corresponding to epoch numbers from EpochNumbers. More...
List< double > | EpochErrorsAbs`[get, set]`
| List of sampled absolute errors corresponding to epoch numbers from EpochNumbers. More...

## Private Attributes
int | _inputLength = DefaultInputLength
int | _outputLength = DefaultOutputLength
double | _inputBoundSafetyFactor = DefaultInputBoundSafetyFactor
| Gets or sets input safety factor. More...
double | _outputBoundSafetyFactor = DefaultOutputBoundSafetyFactor
| Gets or sets output safety factor. More...
IVector | _tolRmsRelative
| Auxiliary properties for defining tolerances in a relative way: More...
double | _tolRmsRelativeScalar = DefaultToleranceRmsRelativeToRangeScalar
IVector | _tolMaxRelative
double | _tolMaxRelativeScalar = DefaultToleranceMaxRelativeToRangeScalar

## Detailed Description

Contains Parameters that define neural network architecture and trainig procedure, together with achieved results after training such as various error norms.

Not thread safe!

This class is used for storing parameters of neural networks and restoring them at a later time, in order to repeat training under similar condition or simply to analyse performance of neural networks.

$A Igor Jul10 May12;

## Member Function Documentation

void IG.Num.NeuralTrainingParameters.SetEpochNumbers | ( | int[] | epochNumbers | ) |
| inline

Sets the list of epoch numbers at which convergence data was sampled.

Parameters

  epochNumbers | Array of epoch numbers from which data is copied.

void IG.Num.NeuralTrainingParameters.SetEpochNumbers | ( | List< int > | epochNumbers | ) |
| inline

Sets the list of epoch numbers at which convergence data was sampled.

Parameters

  epochNumbers | List of epoch numbers from which data is copied.

void IG.Num.NeuralTrainingParameters.SetEpochErrorsRms | ( | double[] | errors | ) |
| inline

Sets the list of sampled RMS errors that correspond to epoch numbers from EpochNumbers.

Parameters

  errors | Array from which data is copied.

void IG.Num.NeuralTrainingParameters.SetEpochErrorsRms | ( | List< double > | errors | ) |
| inline

Sets the list of sampled RMS errors corresponding to epoch numbers from EpochNumbers.

Parameters

  errors | List from which data is copied.

void IG.Num.NeuralTrainingParameters.SetEpochErrorsAbs | ( | double[] | errors | ) |
| inline

Sets the list of sampled absolute errors that correspond to epoch numbers from EpochNumbers.

Parameters

  errors | Array from which data is copied.

void IG.Num.NeuralTrainingParameters.SetEpochErrorsAbs | ( | List< double > | errors | ) |
| inline

Sets the list of sampled absolute errors corresponding to epoch numbers from EpochNumbers.

Parameters

  errors | List from which data is copied.

void IG.Num.NeuralTrainingParameters.CopyFrom | ( | NeuralApproximatorBase | nn | ) |
| inline

Copies current data from the specified neural network approximator.

Parameters

  nn | Neural network approximator that data is copied form.

References IG.Num.VectorBase.Copy(), IG.Num.NeuralApproximatorBase.EpochsInBundle, IG.Num.SampledDataSet.GetInputRange(), IG.Num.SampledDataSet.GetOutputRange(), IG.Num.NeuralApproximatorBase.InputBoundsSafetyFactor, IG.Num.NeuralApproximatorBase.InputLength, IG.Num.NeuralApproximatorBase.LearningRate, IG.Num.NeuralApproximatorBase.MaxEpochs, IG.Num.NeuralApproximatorBase.Momentum, IG.Num.NeuralApproximatorBase.NumHiddenLayers, IG.Num.NeuralApproximatorBase.NumHiddenNeurons, IG.Num.NeuralApproximatorBase.OutputBoundsSafetyFactor, IG.Num.NeuralApproximatorBase.OutputLength, IG.Num.NeuralApproximatorBase.SigmoidAlphaValue, IG.Num.NeuralApproximatorBase.ToleranceMax, IG.Num.NeuralApproximatorBase.ToleranceMaxRelativeToRange, IG.Num.NeuralApproximatorBase.ToleranceMaxRelativeToRangeScalar, IG.Num.NeuralApproximatorBase.ToleranceRms, IG.Num.NeuralApproximatorBase.ToleranceRmsRelativeToRange, IG.Num.NeuralApproximatorBase.ToleranceRmsRelativeToRangeScalar, and IG.Num.NeuralApproximatorBase.TrainingData.

void IG.Num.NeuralTrainingParameters.CopyResultsFrom | ( | NeuralApproximatorBase | nn | ) |
| inline

Copies only results from the trained network to the current object.

Parameters

  nn | Neural network approximator which results are copied from.

References IG.Num.NeuralApproximatorBase.ConvergenceErrorsTrainingMaxList, IG.Num.NeuralApproximatorBase.ConvergenceErrorsTrainingRmsList, IG.Num.NeuralApproximatorBase.ConvergenceErrorsVerificationMaxList, IG.Num.NeuralApproximatorBase.ConvergenceErrorsVerificationRmsList, IG.Num.VectorBase.Copy(), IG.Num.NeuralApproximatorBase.EpochNumbers, IG.Num.NeuralApproximatorBase.GetErrorsTrainingMax(), IG.Num.NeuralApproximatorBase.GetErrorsTrainingMeanAbs(), IG.Num.NeuralApproximatorBase.GetErrorsTrainingRms(), IG.Num.NeuralApproximatorBase.GetErrorsVerificationMax(), IG.Num.NeuralApproximatorBase.GetErrorsVerificationMeanAbs(), IG.Num.NeuralApproximatorBase.GetErrorsVerificationRms(), IG.Num.NeuralApproximatorBase.NetworkTrained, and IG.Num.NeuralApproximatorBase.SaveConvergenceRms.

void IG.Num.NeuralTrainingParameters.CopyTo | ( | NeuralApproximatorBase | nn | ) |
| inline

Copies data that determine neural network and training procedure (such as network architecture, training parameters, tolerances, etc.) from the current object to the specified neural network approximator. This enables to restore training contitions of a peviour training procedure.

Parameters

  nn | Neural network approximator that data is copied to.

References IG.Num.VectorBase.Copy(), IG.Num.NeuralApproximatorBase.EpochsInBundle, IG.Num.NeuralApproximatorBase.InputBoundsSafetyFactor, IG.Num.NeuralApproximatorBase.InputLength, IG.Num.NeuralApproximatorBase.LearningRate, IG.Num.NeuralApproximatorBase.MaxEpochs, IG.Num.NeuralApproximatorBase.Momentum, IG.Num.NeuralApproximatorBase.NumHiddenLayers, IG.Num.NeuralApproximatorBase.OutputBoundsSafetyFactor, IG.Num.NeuralApproximatorBase.OutputLength, IG.Num.NeuralApproximatorBase.SaveConvergenceRms, IG.Num.NeuralApproximatorBase.SetNumNeuronsInHiddenLayer(), IG.Num.NeuralApproximatorBase.SigmoidAlphaValue, IG.Num.NeuralApproximatorBase.ToleranceMax, IG.Num.NeuralApproximatorBase.ToleranceMaxRelativeToRange, IG.Num.NeuralApproximatorBase.ToleranceMaxRelativeToRangeScalar, IG.Num.NeuralApproximatorBase.ToleranceRms, IG.Num.NeuralApproximatorBase.ToleranceRmsRelativeToRange, and IG.Num.NeuralApproximatorBase.ToleranceRmsRelativeToRangeScalar.

static void IG.Num.NeuralTrainingParameters.SaveJson | ( | NeuralTrainingParameters | trainingParameters,
|  | string | filePath
| ) |  |
| inline static

Saves (serializes) the specified training parameters object to the specified JSON file. File is owerwritten if it exists.

Parameters

  trainingParameters | Object that is saved to a file.
  filePath | Path to the file into which object is is saved.

static void IG.Num.NeuralTrainingParameters.SaveJson | ( | NeuralTrainingParameters | trainingParameters,
|  | string | filePath,
|  | bool | append
| ) |  |
| inline static

Saves (serializes) the specified training parameters object to the specified JSON file.

Parameters

  trainingParameters | Object that is saved to a file.
  filePath | Path to the file into which object is is saved.
  append | Specifies whether serialized data is appended at the end of the file in the case that the file already exists.

static void IG.Num.NeuralTrainingParameters.LoadJson | ( | string | filePath,
|  | ref NeuralTrainingParameters | trainingParametersRestored
| ) |  |
| inline static

Restores (deserializes) a training parameters object from the specified file in JSON format.

Parameters

  filePath | File from which object data is restored.
  trainingParametersRestored | Object that is restored by deserialization.

static void IG.Num.NeuralTrainingParameters.SaveJson | ( | NeuralTrainingParameters[] | trainingParameters,
|  | string | filePath
| ) |  |
| inline static

Saves (serializes) the specified array of training parameters objects to the specified JSON file. File is owerwritten if it exists.

Parameters

  trainingParameters | Array that is saved to a file.
  filePath | Path to the file into which object is is saved.

static void IG.Num.NeuralTrainingParameters.SaveJson | ( | NeuralTrainingParameters[] | trainingParameters,
|  | string | filePath,
|  | bool | append
| ) |  |
| inline static

Saves (serializes) the specified array of training parameters objects to the specified JSON file.

Parameters

  trainingParameters | Array that is saved to a file.
  filePath | Path to the file into which object is is saved.
  append | Specifies whether serialized data is appended at the end of the file in the case that the file already exists.

static void IG.Num.NeuralTrainingParameters.LoadJson | ( | string | filePath,
|  | ref NeuralTrainingParameters[] | trainingParametersRestored
| ) |  |
| inline static

Restores (deserializes) an array of training parameters objects from the specified file in JSON format.

Parameters

  filePath | File from which array of objects is restored.
  trainingParametersRestored | Array of objects that is restored by deserialization.

static void IG.Num.NeuralTrainingParameters.SaveJson | ( | List< NeuralTrainingParameters > | trainingParameters,
|  | string | filePath
| ) |  |
| inline static

Saves (serializes) the specified list of training parameters objects to the specified JSON file. File is owerwritten if it exists.

Parameters

  trainingParameters | List that is saved to a file.
  filePath | Path to the file into which object is is saved.

static void IG.Num.NeuralTrainingParameters.SaveJson | ( | List< NeuralTrainingParameters > | trainingParameters,
|  | string | filePath,
|  | bool | append
| ) |  |
| inline static

Saves (serializes) the specified list of training parameters objects to the specified JSON file.

Parameters

  trainingParameters | List that is saved to a file.
  filePath | Path to the file into which object is is saved.
  append | Specifies whether serialized data is appended at the end of the file in the case that the file already exists.

static void IG.Num.NeuralTrainingParameters.LoadJson | ( | string | filePath,
|  | ref List< NeuralTrainingParameters > | trainingParametersRestored
| ) |  |
| inline static

Restores (deserializes) a list of training parameters objects from the specified file in JSON format.

Parameters

  filePath | File from which list of objects is restored.
  trainingParametersRestored | Array of objects that is restored by deserialization.

static void IG.Num.NeuralTrainingParameters.SaveCSV | ( | List< NeuralTrainingParameters > | trainingParameters,
|  | string | filePath
| ) |  |
| inline static

Saves the specified list of training parameters objects to the specified CSV file.

Parameters

  trainingParameters | List that is saved to a file.
  filePath | Path to the file into which object is is saved.

$A Tako78 Sep12;

static double IG.Num.NeuralTrainingParameters.ErrorAverageCalc | ( | List< IVector > | ErrorConvergence,
|  | int | NumLastErrors,
|  | int | NumBundles,
|  | IVector | scalingLength
| ) |  |
| inline static protected

Calculate average number of the desired number of first elements in the convergence list.

Parameters

  ErrorConvergence | List of convergence errors.
  NumLastErrors | Number of elemnts in the convergence list.

Returns
  Average number.

References IG.Num.VectorBase.NormWeighted().

static double IG.Num.NeuralTrainingParameters.ErrorAverageCalc | ( | List< IVector > | ErrorConvergence,
|  | int | NumLastErrors,
|  | int | NumBundles
| ) |  |
| inline static protected

Calculate average number of the desired number of first elements in the convergence list.

Parameters

  ErrorConvergence | List of convergence errors.
  NumLastErrors | Number of elemnts in the convergence list.

Returns
  Average number.

IComparer<IVector> IG.Num.NeuralTrainingParameters.CreateComparerErrorTrainingRmsVector | ( |  | ) |
| inline protected

static ComparerTrainingTime IG.Num.NeuralTrainingParameters.CreateComparerTrainingTime | ( |  | ) |
| inline static

## Member Data Documentation

double IG.Num.NeuralTrainingParameters.DefaultLearningRate = 0.1
| static

Default value for learning rate in neural networks.

double IG.Num.NeuralTrainingParameters.DefaultMomentum = 0.5
| static

Default value of momentum for neural networks.

double IG.Num.NeuralTrainingParameters.DefaultSigmoidAlphaValue = 1.5
| static

Default value of the sigmoid alpha value (used in networks with sigmoid activation functions).

int IG.Num.NeuralTrainingParameters.DefaultEpochsInBundle
| static

Default value for number of epochs in bundle (i.e. number of epochs performed at once, without any checks or output operations between).

int IG.Num.NeuralTrainingParameters.DefaultNumHiddenLayers = 1
| static

Default number of hidden layers.

int IG.Num.NeuralTrainingParameters.DefaultNumHiddenNeurons = 20
| static

Default number of hidden neurons in a layer

int IG.Num.NeuralTrainingParameters.DefaultMaxEpochs = 40000
| static

Default value for maximal number of epochs.

IVector IG.Num.NeuralTrainingParameters.DefaultToleranceRms = null
| static

Default value for tollerance on RMS error in neural networks.

IVector IG.Num.NeuralTrainingParameters.DefaultToleranceMax = null
| static

Default value for tollerance on max. abs. error in neural networks.

double IG.Num.NeuralTrainingParameters.DefaultToleranceRmsRelativeToRangeScalar = 0.1
| static

Default value for the tolerance on RMS error, relative to the output range.

double IG.Num.NeuralTrainingParameters.DefaultToleranceMaxRelativeToRangeScalar = 0
| static

Default value for the tolerance on max. abs. error, relative to the output range.

int IG.Num.NeuralTrainingParameters.DefaultInputLength = 1
| static

Default number of input neurons.

int IG.Num.NeuralTrainingParameters.DefaultOutputLength = 1
| static

Default number of output neurons.

double IG.Num.NeuralTrainingParameters.DefaultInputBoundSafetyFactor = 1.5
| static

Default number of input safety factor.

double IG.Num.NeuralTrainingParameters.DefaultOutputBoundSafetyFactor = 1.5
| static

Default number of output safety factor.

double IG.Num.NeuralTrainingParameters._learningRate = DefaultLearningRate
| protected

double IG.Num.NeuralTrainingParameters._momentum = DefaultMomentum
| protected

double IG.Num.NeuralTrainingParameters._sigmoidAlphaValue = DefaultSigmoidAlphaValue
| protected

int IG.Num.NeuralTrainingParameters._inputLength = DefaultInputLength
| private

int IG.Num.NeuralTrainingParameters._outputLength = DefaultOutputLength
| private

double IG.Num.NeuralTrainingParameters._inputBoundSafetyFactor = DefaultInputBoundSafetyFactor
| private

Gets or sets input safety factor.

double IG.Num.NeuralTrainingParameters._outputBoundSafetyFactor = DefaultOutputBoundSafetyFactor
| private

Gets or sets output safety factor.

int IG.Num.NeuralTrainingParameters._maxEpochs = DefaultMaxEpochs
| protected

int IG.Num.NeuralTrainingParameters._epochInBundle = DefaultEpochsInBundle
| protected

IVector IG.Num.NeuralTrainingParameters._outputRange
| protected

IBoundingBox IG.Num.NeuralTrainingParameters._outputNeuronRange
| protected

IVector IG.Num.NeuralTrainingParameters._inputRange
| protected

IBoundingBox IG.Num.NeuralTrainingParameters._inputNeuronRange
| protected

IVector IG.Num.NeuralTrainingParameters._toleranceRms
| protected

IVector IG.Num.NeuralTrainingParameters._toleranceMax
| protected

IVector IG.Num.NeuralTrainingParameters._tolRmsRelative
| private

Auxiliary properties for defining tolerances in a relative way:

double IG.Num.NeuralTrainingParameters._tolRmsRelativeScalar = DefaultToleranceRmsRelativeToRangeScalar
| private

IVector IG.Num.NeuralTrainingParameters._tolMaxRelative
| private

double IG.Num.NeuralTrainingParameters._tolMaxRelativeScalar = DefaultToleranceMaxRelativeToRangeScalar
| private

int IG.Num.NeuralTrainingParameters._numHiddenLayers = DefaultNumHiddenLayers
| protected

int [] IG.Num.NeuralTrainingParameters._numHiddenNeurons = null
| protected

bool IG.Num.NeuralTrainingParameters._isNetworkTrained = false
| protected

IVector IG.Num.NeuralTrainingParameters._errorsTrainingRms
| protected

List<IVector> IG.Num.NeuralTrainingParameters._errorsTrainingRmsList = null

IVector IG.Num.NeuralTrainingParameters._errorsTrainingMax
| protected

List<IVector> IG.Num.NeuralTrainingParameters._errorsTrainingMaxList = null

IVector IG.Num.NeuralTrainingParameters._errorsTrainingMeanAbs
| protected

IVector IG.Num.NeuralTrainingParameters._errorsVerificationRms
| protected

List<IVector> IG.Num.NeuralTrainingParameters._errorsVerificationRmsList = null

IVector IG.Num.NeuralTrainingParameters._errorsVerificationMax
| protected

List<IVector> IG.Num.NeuralTrainingParameters._errorsVerificationMaxList = null

IVector IG.Num.NeuralTrainingParameters._errorsVerificationMeanAbs
| protected

bool IG.Num.NeuralTrainingParameters._convergenceRmsEnabled = false

int IG.Num.NeuralTrainingParameters._numEpochs = 0
| protected

double IG.Num.NeuralTrainingParameters._trainingTime = 0
| protected

double IG.Num.NeuralTrainingParameters._trainingCpuTime = 0
| protected

List<int> IG.Num.NeuralTrainingParameters._EpochNumbers
| protected

List<double> IG.Num.NeuralTrainingParameters._EpochErrorsRms
| protected

List<double> IG.Num.NeuralTrainingParameters._EpochErrorsAbs
| protected

## Property Documentation

double IG.Num.NeuralTrainingParameters.LearningRate
| get set

Learning rate.

Referenced by IG.Num.NeuralTrainingParametersDto.CopyFromPlain(), and IG.Num.NeuralTrainingLimits.IterateThroughMultidimensionalTable().

double IG.Num.NeuralTrainingParameters.Momentum
| get set

Momentum. Specifies how much changes of weight in the previous iterations affect changes in the current iterations.

Referenced by IG.Num.NeuralTrainingParametersDto.CopyFromPlain(), and IG.Num.NeuralTrainingLimits.IterateThroughMultidimensionalTable().

double IG.Num.NeuralTrainingParameters.SigmoidAlphaValue
| get set

Sigmoid alpha value (used in networks with sigmoid activation functions).

Referenced by IG.Num.NeuralTrainingParametersDto.CopyFromPlain(), and IG.Num.NeuralTrainingLimits.IterateThroughMultidimensionalTable().

virtual int IG.Num.NeuralTrainingParameters.InputLength
| get set

Gets or sets the number of input neurons.

Referenced by IG.Num.NeuralTrainingParametersDto.CopyFromPlain(), and IG.Num.NeuralTrainingLimits.IterateThroughMultidimensionalTable().

virtual int IG.Num.NeuralTrainingParameters.OutputLength
| get set

Gets or sets the number of output neurons.

Referenced by IG.Num.NeuralTrainingParametersDto.CopyFromPlain(), and IG.Num.NeuralTrainingLimits.IterateThroughMultidimensionalTable().

virtual double IG.Num.NeuralTrainingParameters.InputBoundSafetyFactor
| get set

Gets or sets input safety factor.

Referenced by IG.Num.NeuralTrainingParametersDto.CopyFromPlain(), and IG.Num.NeuralTrainingLimits.IterateThroughMultidimensionalTable().

virtual double IG.Num.NeuralTrainingParameters.OutputBoundSafetyFactor
| get set

Gets or sets output safety factor.

Referenced by IG.Num.NeuralTrainingParametersDto.CopyFromPlain(), and IG.Num.NeuralTrainingLimits.IterateThroughMultidimensionalTable().

int IG.Num.NeuralTrainingParameters.MaxEpochs
| get set

Maximal number of epochs performed in the training procedure.

Referenced by IG.Num.NeuralTrainingParametersDto.CopyFromPlain(), and IG.Num.NeuralTrainingLimits.IterateThroughMultidimensionalTable().

int IG.Num.NeuralTrainingParameters.EpochsInBundle
| get set

Number of epochs in bundle (i.e. number of epochs performed at once, without any checks or output operations between).

This parameter does not affect the training procedure in terms of results.

Referenced by IG.Num.NeuralTrainingParametersDto.CopyFromPlain(), and IG.Num.NeuralTrainingLimits.IterateThroughMultidimensionalTable().

IVector IG.Num.NeuralTrainingParameters.OutputRange
| get set

Range from actual outputs.

$A Tako78 Octl12;

Referenced by IG.Num.NeuralTrainingParametersDto.CopyFromPlain().

IBoundingBox IG.Num.NeuralTrainingParameters.OutputNeuronRange
| get set protected

Bounding box from actual outputs.

$A Tako78 Octl12;

IVector IG.Num.NeuralTrainingParameters.InputRange
| get set

Range from actual inputs.

$A Tako78 Octl12;

Referenced by IG.Num.NeuralTrainingParametersDto.CopyFromPlain().

IBoundingBox IG.Num.NeuralTrainingParameters.InputNeuronRange
| get set protected

Bounding box from actual inputs.

$A Tako78 Octl12;

IVector IG.Num.NeuralTrainingParameters.ToleranceRms
| get set

Tolerance over RMS error of output over training points. Training will continue until error becomes below tolerance or until maximal number of epochs is reached. If less or equal than 0 then this tolerance is not taken into account.

Referenced by IG.Num.NeuralTrainingParametersDto.CopyFromPlain(), and IG.Num.NeuralTrainingLimits.IterateThroughMultidimensionalTable().

IVector IG.Num.NeuralTrainingParameters.ToleranceMax
| get set

Tolerance on maximal error of output over training points. Training will continue until error becomes below tolerance or until maximal number of epochs is reached. If less or equal than 0 then this tolerance is not taken into account.

Referenced by IG.Num.NeuralTrainingParametersDto.CopyFromPlain(), and IG.Num.NeuralTrainingLimits.IterateThroughMultidimensionalTable().

IVector IG.Num.NeuralTrainingParameters.ToleranceRmsRelativeToRange
| get set

Relative tolerances on RMS errors of outputs over training points, relative to the correspoinding ranges of output data.

See also
  NeuralApproximatorBase.ToleranceRmsRelativeToRange

Referenced by IG.Num.NeuralTrainingParametersDto.CopyFromPlain(), and IG.Num.NeuralTrainingLimits.IterateThroughMultidimensionalTable().

double IG.Num.NeuralTrainingParameters.ToleranceRmsRelativeToRangeScalar
| get set

Scalar through which all components of the Relative tolerances on RMS errors of outputs can be set to the same value.

See also
  NeuralApproximatorBase.ToleranceRmsRelativeToRangeScalar

Referenced by IG.Num.NeuralTrainingParametersDto.CopyFromPlain(), and IG.Num.NeuralTrainingLimits.IterateThroughMultidimensionalTable().

IVector IG.Num.NeuralTrainingParameters.ToleranceMaxRelativeToRange
| get set

Relative tolerances on max. abs. errors of outputs over training points, relative to the correspoinding ranges of output data.

See also
  NeuralApproximatorBase.ToleranceMaxRelativeToRange

Referenced by IG.Num.NeuralTrainingParametersDto.CopyFromPlain(), and IG.Num.NeuralTrainingLimits.IterateThroughMultidimensionalTable().

double IG.Num.NeuralTrainingParameters.ToleranceMaxRelativeToRangeScalar
| get set

Scalar through which all components of the Relative tolerances on max. abs. errors of outputs can be set to the same value.

See also
  NeuralApproximatorBase.ToleranceMaxRelativeToRangeScalar

Referenced by IG.Num.NeuralTrainingParametersDto.CopyFromPlain(), and IG.Num.NeuralTrainingLimits.IterateThroughMultidimensionalTable().

int IG.Num.NeuralTrainingParameters.NumHiddenLayers
| get set

Number of Hideden layers.

Referenced by IG.Num.NeuralTrainingParametersDto.CopyFromPlain(), and IG.Num.NeuralTrainingLimits.IterateThroughMultidimensionalTable().

int [] IG.Num.NeuralTrainingParameters.NumHidenNeurons
| get set

Numbers of neurons in each hidden layer.

Referenced by IG.Num.NeuralTrainingParametersDto.CopyFromPlain(), and IG.Num.NeuralTrainingLimits.IterateThroughMultidimensionalTable().

bool IG.Num.NeuralTrainingParameters.IsNetworkTrained
| get set

Whether the network is trained (and results exist).

Referenced by IG.Num.NeuralTrainingParametersDto.CopyFromPlain().

IVector IG.Num.NeuralTrainingParameters.ErrorsTrainingRms
| get set

RMS errors calculated on training data.

Referenced by IG.Num.NeuralTrainingParametersDto.CopyFromPlain().

List<IVector> IG.Num.NeuralTrainingParameters.ErrorsTrainingRmsList
| get set

Convergence List of Rms errors calculated on training data.

Referenced by IG.Num.NeuralTrainingParametersDto.CopyFromPlain().

IVector IG.Num.NeuralTrainingParameters.ErrorsTrainingMax
| get set

Maximal errors calculated on training data.

Referenced by IG.Num.NeuralTrainingParametersDto.CopyFromPlain().

List<IVector> IG.Num.NeuralTrainingParameters.ErrorsTrainingMaxList
| get set

Convergence List of Maximal errors calculated on training data.

Referenced by IG.Num.NeuralTrainingParametersDto.CopyFromPlain().

IVector IG.Num.NeuralTrainingParameters.ErrorsTrainingMeanAbs
| get set

Mean absolute errors calculated on training data.

Referenced by IG.Num.NeuralTrainingParametersDto.CopyFromPlain().

IVector IG.Num.NeuralTrainingParameters.ErrorsVerificationRms
| get set

RMS errors calculated on verification data.

Referenced by IG.Num.NeuralTrainingParametersDto.CopyFromPlain().

List<IVector> IG.Num.NeuralTrainingParameters.ErrorsVerificationRmsList
| get set

Convergence List of RMS errors calculated on verification data.

Referenced by IG.Num.NeuralTrainingParametersDto.CopyFromPlain().

IVector IG.Num.NeuralTrainingParameters.ErrorsVerificationMax
| get set

Maximal errors calculated on verification data.

Referenced by IG.Num.NeuralTrainingParametersDto.CopyFromPlain().

List<IVector> IG.Num.NeuralTrainingParameters.ErrorsVerificationMaxList
| get set

Convergence List of Maximal errors calculated on verification data.

Referenced by IG.Num.NeuralTrainingParametersDto.CopyFromPlain().

IVector IG.Num.NeuralTrainingParameters.ErrorsVerificationMeanAbs
| get set

Maximal errors calculated on training data.

Referenced by IG.Num.NeuralTrainingParametersDto.CopyFromPlain().

bool IG.Num.NeuralTrainingParameters.SaveConvergenceRms
| get set

int IG.Num.NeuralTrainingParameters.NumEpochs
| get set

Number of epochs actually spent at training.

This may be less than MaxEpochs if convergence is reached before.

Referenced by IG.Num.NeuralTrainingParametersDto.CopyFromPlain().

double IG.Num.NeuralTrainingParameters.TrainingTime
| get set

Time spent for training.

Referenced by IG.Num.NeuralTrainingParametersDto.CopyFromPlain().

double IG.Num.NeuralTrainingParameters.TrainingCpuTime
| get set

CPU time spent for training.

Referenced by IG.Num.NeuralTrainingParametersDto.CopyFromPlain().

List<int> IG.Num.NeuralTrainingParameters.EpochNumbers
| get protected set

List of epoch numbers at which convergence data was sampled.

Referenced by IG.Num.NeuralTrainingParametersDto.CopyFromPlain().

List<double> IG.Num.NeuralTrainingParameters.EpochErrorsRms
| get set

List of sampled RMS errors corresponding to epoch numbers from EpochNumbers.

Referenced by IG.Num.NeuralTrainingParametersDto.CopyFromPlain().

List<double> IG.Num.NeuralTrainingParameters.EpochErrorsAbs
| get set

List of sampled absolute errors corresponding to epoch numbers from EpochNumbers.

Referenced by IG.Num.NeuralTrainingParametersDto.CopyFromPlain().

The documentation for this class was generated from the following file:

- igbase/numeric/approximation/neural/NeuralTrainingParameters.cs